'use strict';

exports.__esModule = true;
exports.blur = blur;
exports.change = change;
exports.initialize = initialize;
exports.reset = reset;
exports.touch = touch;
exports.touchAll = touchAll;
exports.untouch = untouch;
exports.untouchAll = untouchAll;

var _actionTypes = require('./actionTypes');

function blur(form, field, value) {
  return {
    type: _actionTypes.BLUR,
    form: form,
    field: field,
    value: value
  };
}

function change(form, field, value) {
  return {
    type: _actionTypes.CHANGE,
    form: form,
    field: field,
    value: value
  };
}

function initialize(form, data) {
  return {
    type: _actionTypes.INITIALIZE,
    form: form,
    data: data
  };
}

function reset(form) {
  return {
    type: _actionTypes.RESET,
    form: form
  };
}

function touch(form) {
  for (var _len = arguments.length, fields = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    fields[_key - 1] = arguments[_key];
  }

  return {
    type: _actionTypes.TOUCH,
    form: form,
    fields: fields
  };
}

function touchAll(form) {
  return {
    type: _actionTypes.TOUCH_ALL,
    form: form
  };
}

function untouch(form) {
  for (var _len2 = arguments.length, fields = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    fields[_key2 - 1] = arguments[_key2];
  }

  return {
    type: _actionTypes.UNTOUCH,
    form: form,
    fields: fields
  };
}

function untouchAll(form) {
  return {
    type: _actionTypes.UNTOUCH_ALL,
    form: form
  };
}