'use strict';

exports.__esModule = true;
exports.getDisplayName = getDisplayName;
exports.isPristine = isPristine;

function getDisplayName(Comp) {
  return Comp.displayName || Comp.name || 'Component';
}

function isPristine(initial, data) {
  if (initial === data) {
    return true;
  }
  var dataKeys = Object.keys(data);
  for (var i = 0; i < dataKeys.length; i++) {
    var key = dataKeys[i];
    var value = data[key];
    var initialValue = initial[key];
    if ((value || initialValue) && /* allow '' to equate to undefined or null */value !== initialValue) {
      return false;
    }
  }
  return true;
}